package com.example.helloaquestalk;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import android.media.MediaPlayer;
import android.util.Log;
import android.widget.TextView;
import java.io.*;
import aquestalk.AquesTalk;	// AquesTalkクラス 別途libAquesTalk.soが必要

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        setContentView(R.layout.activity_main);

        String koe = "ゆっくりしていってね？";
        int    speed = 90; // 発話速度　50-300　default:100
        // 音声合成
//		byte[] wav = AquesTalk.synthe(koe, speed); //< 静的メソッドもOK
        AquesTalk aquestalk = new AquesTalk();
        byte[] wav = aquestalk.syntheWav(koe, speed);

        if(wav.length==1){//生成エラー時には,長さ１で、先頭にエラーコードが返される
            Log.v("AQTKAPP", "AquesTalk Synthe ERROR:"+wav[0]);
        }
        else {
            PlayWav(wav);//音声データを再生出力
        }

        TextView textView = new TextView(this);
        textView.setText("音声記号列："+koe+" speed:"+speed);
        setContentView(textView);
    }
    private void PlayWav(byte[] wav) {
        // 一旦ファイルに出力してから、MediaPlayerで再生
        String tmpfilename = "tmp_hello.wav";
        String packagename = removeSuffix(this.getClass().getName());

        try {
            FileOutputStream fileOutputStream = openFileOutput(tmpfilename, MODE_PRIVATE );
            fileOutputStream.write(wav);
            fileOutputStream.close();
        } catch (IOException e) {
            Log.e("AQTKAPP", "ERR: FileOutputStream");
        }
        try {
            MediaPlayer mp = new MediaPlayer();
            // mp.reset();	// MediaPlayerインスタンスを複数回使うときは必要
            mp.setDataSource("/data/data/"+packagename+"/files/"+tmpfilename);
            mp.prepare();	//<<忘れると動かない　(-38,0)のようなエラーがでる
            mp.start();
        } catch (IOException e) {
        }
    }

    public static String removeSuffix(String fileName) {
        if (fileName == null)
            return null;
        int point = fileName.lastIndexOf(".");
        if (point != -1) {
            return fileName.substring(0, point);
        }
        return fileName;
    }

}
